=== debian/control ===
Source: python-psutil
Section: python
Priority: optional
Maintainer: Sandro Tosi <morph@debian.org>
Build-Depends: debhelper-compat (= 13),
               procps,
               pybuild-plugin-pyproject,
               python3-all-dev,
               python3-setuptools,
Standards-Version: 4.6.1.0
Homepage: https://github.com/giampaolo/psutil
Vcs-Git: https://salsa.debian.org/morph/python-psutil.git
Vcs-Browser: https://salsa.debian.org/morph/python-psutil
Testsuite: autopkgtest-pkg-python

Package: python3-psutil
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Description: module providing convenience functions for managing processes (Python3)
 psutil is a module providing an interface for retrieving information on
 running processes and system utilization (CPU, memory) in a portable way
 by using Python, implementing many functionalities offered by tools like
 ps, top and Windows task manager.
 .
 It currently supports Linux, OS X, FreeBSD and Windows.
 .
 This package contains the Python 3 version of psutil.
