=== debian/changelog ===
python-psutil (7.0.0-2) unstable; urgency=medium

  * debian/rules
    - temporarily skip some tests that fail during build; Closes: #1101865

 -- Sandro Tosi <morph@debian.org>  Sat, 12 Apr 2025 01:20:24 -0400

python-psutil (7.0.0-1) unstable; urgency=medium

  * New upstream release; Closes: #1086528
  * debian/patches/*
    - refresh patches
  * run test via pybuild and pytest

 -- Sandro Tosi <morph@debian.org>  Sun, 16 Mar 2025 03:45:24 -0400
