=== debian/control ===
--- 
+++ 
@@ -6,6 +6,8 @@
                procps,
                pybuild-plugin-pyproject,
                python3-all-dev,
+               python3-pytest <!nocheck>,
+               python3-pytest-xdist <!nocheck>,
                python3-setuptools,
 Standards-Version: 4.6.1.0
 Homepage: https://github.com/giampaolo/psutil
