=== debian/changelog ===
python-psutil (7.1.0-1ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - linux: handle missing /sys/class/power_supply in sensors_battery()

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 21 Oct 2025 11:11:50 +0200

python-psutil (7.1.0-1) unstable; urgency=medium

  * New upstream release
  * refresh patches
  * debian/control
    - add pytest-instafail, pytest-subtests to b-d, needed by tests

 -- Sandro Tosi <morph@debian.org>  Sun, 05 Oct 2025 02:26:16 -0400

python-psutil (7.0.0-2ubuntu1) questing; urgency=medium

  * linux: handle missing /sys/class/power_supply in sensors_battery()

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 30 Jun 2025 14:11:02 +0200
