=== debian/control ===
--- 
+++ 
@@ -1,12 +1,15 @@
 Source: python-psutil
 Section: python
 Priority: optional
-Maintainer: Sandro Tosi <morph@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sandro Tosi <morph@debian.org>
 Build-Depends: debhelper-compat (= 13),
                procps,
                pybuild-plugin-pyproject,
                python3-all-dev,
                python3-pytest <!nocheck>,
+               python3-pytest-instafail <!nocheck>,
+               python3-pytest-subtests <!nocheck>,
                python3-pytest-xdist <!nocheck>,
                python3-setuptools,
 Standards-Version: 4.6.1.0
